/* eslint-disable no-unused-components */
<script lang="ts">
import Vue from 'vue';
import { CONTENT_TYPES } from '../../common/content-types';
import { getPageMetadata } from '../../common/meta';
import { CropInfinityHero, NextStepAlt } from '~/components/common/index.vue';
import {
  ResourcesBrowser,
  ResourcesFeaturedItems,
  ResourcesNextSteps,
  ResourcesStartHere,
} from '~/components/resources/index.vue';
import { getClient } from '~/plugins/contentful.js';
import { ContentfulLivePreview } from '@contentful/live-preview';
import { FooterEditLinkMixin, LivePreviewMixin } from '~/mixins';

function mapResources(items) {
  const metadata = {
    title: items.seoMetadata[0].fields.ogTitle,
    ogTitle: items.seoMetadata[0].fields.ogTitle,
    description: items.seoMetadata[0].fields?.description,
    ogDescription: items.seoMetadata[0].fields.ogDescription,
    ogType: items.seoMetadata[0].fields.ogType,
    ogUrl: items.seoMetadata[0].fields.ogUrl,
    ogSiteName: items.seoMetadata[0].fields.ogSiteName,
    ogImage: items.seoMetadata[0].fields.ogImage,
  };

  let hero, nextStepAlts, startHere, featuredItems, resources;

  items.pageContent.forEach((item) => {
    switch (item.fields.componentName) {
      case 'crop-infinity-hero':
        hero = {
          title: item.fields.title,
          subtitle: item.fields?.description,
          primary_btn: item.fields.primaryCta.fields,
        };
        break;
      case 'resources-start-here':
        startHere = {
          title: item.fields.header,
          cards: item.fields.card,
        };
        break;
      case 'resources-featured-items':
        featuredItems = {
          title: item.fields.header,
          featured_card: item.fields.card[0].fields,
          featured_card_image: item.fields.card[0].fields.image.fields,
          cards: [
            item.fields.card[1].fields,
            item.fields.card[2].fields,
            item.fields.card[3].fields,
          ],
        };
        break;
      case 'resources-next-steps':
        nextStepAlts = {
          title: item.fields.header,
          cards: item.fields.card.map((card) => card.fields),
        };
        break;
      case 'resources-browser':
        resources = {
          learn_more_text: item.fields.customFields.learn_more_text,
          load_more_text: item.fields.customFields.load_more_text,
          title: item.fields.header,
          cards: item.fields.card.map((card) => {
            return {
              title: card.fields.title,
              url: card.fields.cardLink,
              type: card.fields.iconName,
              language: card.fields.subtitle,
              teaser: card.fields.description,
              topics: card.fields.list,
              solutions: card.fields.pills,
            };
          }),
        };
        break;
      default:
        break;
    }
  });

  return {
    hero,
    startHere,
    metadata,
    resources,
    featuredItems,
    nextStepAlts,
  };
}

export default Vue.extend({
  name: 'ResourcesPage',
  components: {
    CropInfinityHero,
    ResourcesStartHere,
    ResourcesBrowser,
    ResourcesFeaturedItems,
    ResourcesNextSteps,
    NextStepAlt,
  },
  nuxtI18n: false,
  mixins: [LivePreviewMixin, FooterEditLinkMixin],
  async asyncData() {
    try {
      const { items } = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'fields.slug': 'resources',
        include: 10,
      });
      const spaceId = items[0].sys.space.sys.id;
      const entryId = items[0].sys.id;
      const resources = mapResources(items[0].fields);

      return { resources, items, spaceId, entryId };
    } catch (error) {
      throw new Error(error);
    }
  },
  head() {
    return getPageMetadata((this as any).resources.metadata, this.$route.path);
  },
  mounted() {
    if (this.isPreview) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.items,
        callback: (updatedData) => (this.resources = mapResources(updatedData)),
      });
      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
});
</script>
<template>
  <div>
    <CropInfinityHero v-if="resources.hero" :data="resources.hero" />
    <ResourcesStartHere
      v-if="resources.startHere"
      :data="resources.startHere"
    />
    <ResourcesFeaturedItems
      v-if="resources.featuredItems"
      :data="resources.featuredItems"
    />
    <ResourcesBrowser id="resource-browser" :data="resources.resources" />
    <ResourcesNextSteps
      v-if="resources.nextSteps"
      :data="resources.nextSteps"
    />
    <NextStepAlt />
  </div>
</template>

<style scoped lang="scss"></style>
